import 'ol/ol.css';
import {Map, View} from 'ol';
import OSM from 'ol/source/OSM.js';
import XYZ from 'ol/source/XYZ.js';
import GPX from 'ol/format/GPX.js';
import {defaults as defaultControls, FullScreen} from 'ol/control.js';
import {Tile as TileLayer, Vector as VectorLayer} from 'ol/layer.js';
import VectorSource from 'ol/source/Vector.js';
import {Stroke, Style} from 'ol/style.js';

const map = new Map({
	controls: defaultControls().extend([
		new FullScreen()
	]),
	target: 'map',
	layers: [],
	view: new View({
		center: [0, 0],
		zoom: 0
	})
});
var tileSource_oSTREETm = new OSM();
var tileSource_ArcGIS = new XYZ({//==>; esri sat
	attributions: '&copy; <a href="https://server.arcgisonline.com/ArcGIS/rest/services/">ArcGIS</a>',
	url: 'https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}'
});
map.addLayer(new TileLayer({ //==>; osm = default
	source: tileSource_oSTREETm
}));
var vectorSource = new VectorSource({
	url: 'https://biketory.nl/media/content/ol_tutorial.gpx',
	format: new GPX()
});
var vectorStyle = new Style({
	stroke: new Stroke({
		color: 'red',
		width: 3,
		opacity: 0.5
	})
});
map.addLayer(new VectorLayer({
	source: vectorSource,
	style: vectorStyle
}));
var layers = map.getLayers().getArray();
vectorSource.once('change',function(e){
	if(vectorSource.getState() === 'ready') {
		if(layers[1].getSource().getFeatures().length > 0) {
			map.getView().fit(vectorSource.getExtent());
		}
	}
});
var select = document.getElementById('tilesource');
function onChange() {
	var newMap = select.value;
	if(newMap) {
		var tileSource	='tileSource_' + newMap;
		var mapSource	= eval(tileSource);
		var mapLayer0	= layers[0];
		mapLayer0.setSource(mapSource);
	}
}
select.addEventListener('change', onChange);